/*$Id: firekeeper.js,v 1.9 2006/08/11 15:13:33 jwrobel Exp $*/
/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Firekeeper.
 *
 * The Initial Developer of the Original Code is
 * Jan Wrobel <wrobel@blues.ath.cx>.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Alternatively, the contents of this file may be used under the terms of
 * the GNU General Public License Version 2 or later (the "GPL"), in
 * which case the provisions of the GPL are applicable instead of
 * those above. If you wish to allow use of your version of this file
 * only under the terms of the GPL, and not to allow others to use
 * your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the
 * notice and other provisions required by the GPL. If you do not
 * delete the provisions above, a recipient may use your version of
 * this file under the terms of any one of the MPL or the GPL.
 *
 * ***** END LICENSE BLOCK ***** */


function FirekeeperState(initState) {
	this.state = initState;
	
	this.changeState = function(state, msg){
		statusBar = document.getElementById('firekeeper-status');
		statusBar.setAttribute('status', state);
		statusBar.setAttribute('tooltiptext', msg);
		this.state = state;		
	}
}

function firekeeperInit(event)
{	
	debug.init();
	firekeeperState = FirekeeperState("loading");

	var FIREKEEPER_CONTRACTID = "@firekeeper.mozdev.org/firekeeper"
	firekeeper  = Components.classes[FIREKEEPER_CONTRACTID];
	
	if (firekeeper == null){
		var errMsg = "Firekeeper load failed: " + 
			"component " + FIREKEEPER_CONTRACTID + 
			" not registered";
		firekeeperState.changeState("error", errMsg);
		throw(errMsg);
	}

	firekeeper = firekeeper.getService(Components.interfaces.fkIFirekeeper);
	if (firekeeper == null){
		var errMsg = "Firekeeper load failed: " +
			"can't obtain fkIFirekeeper interface";
		firekeeperState.changeState("error", errMsg);
		throw(errMsg);
	}
	try{
		fkRulesLoader = new RulesLoader();
		fkRulesLoader.init();
		fkJudge.init();
		firekeeper.setJudge(fkJudge);
		firekeeperState.changeState("loaded", "Firekeeper is enabled");
	}catch(e){
		errMsg = "Firekeeper initialization failed " + e;
		firekeeperState.
			changeState("error", errMsg);
		throw(errMsg);
	}

}


function openViewRulesWindow()
{
	window.open('chrome://firekeeper/content/config.xul', '_blank', 
		    'chrome,dialog=no,resizable,centerscreen');
}

window.addEventListener('load', getServices, false);

